# -*- coding: utf-8 -*-

#4a) Il processo di traduzione tipicamente inizia dalla tripletta AUG in 
# prossimità dell'estremità 5' dell'mRNA. In alcuni casi l'aggancio del 
# ribosoma può non avvenire, qualora sia presente una pirimidina immediatamente 
# dopo la tripletta oppure in posizione -3 rispetto all'adenosina di AUG.
# Si scriva una funzione spot_leaky(dna) che, data una stringa (lineare) di dna,
# restituisca una lista con le posizioni (in ordine crescente) della tripletta 
# ATG in cui si verificano le condizioni descritte.
#
# Es: spot_leaky("TAAATGTGCATGCGGATGA") ->  [3, 9]
#     spot_leaky("TAAATGTGCATGCGGATGC") ->  [3, 9, 15]


import re

def spot_leaky(dna):
    pattern=re.compile(r"[CT]..ATG[CT]")
    res=[]
    i=prev_i=0
    #also partial overlap of matches is considered
    while True:
        match=pattern.search(dna[i:])
        if match is not None:
            i=prev_i+match.start()+3
            res.append(i)
            prev_i=i          
        else:
            break
    return res
        